# -*- coding: utf-8 -*-



import numpy as np

import matplotlib.pyplot as plt



tmin = 0

tmax = 20

nbx = 20

nbi = nbx - 1 # nombre d'intervalles



x = np.linspace(tmin, tmax, nbx)



u = 325*np.sin(314*x/1000)

i = 6*np.sin(314*x/1000-np.pi/4)

p = u*i



# pour l'affichage des grandeurs u, i et p 

# pour fixer la taille de la figure largeur puis hauteur 

figure = plt.figure(figsize = (6, 7)) 



plt.subplot(311) # nombre de ligne, de colonne, numero de la figure

# affichage de la tension u(t) (bleu)

plt.plot(x,u,"bo-")

plt.ylabel('tension en volt', color="blue")

plt.grid()



#affichage de l'intensité i(t) (rouge)

plt.subplot(312)

plt.plot(x,i, "rx-")

plt.ylabel('intensité en ampère', color="red")

plt.grid()



# affichage de la tension p(t) (vert)

plt.subplot(313)

plt.plot(x,p,"g+-")

plt.xlabel('temps en milliseconde')

plt.ylabel('puissance en watt', color="green")

plt.grid()



integrale = 0

for i in range(nbi):

    integrale = integrale + p[i]*(x[i+1]-x[i])

    # dessin du rectangle

    x_rect = [x[i], x[i], x[i+1], x[i+1], x[i]] # abscisses des sommets

    p_rect = [0   , p[i], p[i]  , 0     , 0   ] # ordonnees des sommets

    plt.plot(x_rect, p_rect,"y")



plt.show()

print("intégrale ou Puissance moyenne =", round(integrale/tmax), "W")



